package net.ihe.gazelle.maven.plugins.messages;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Properties;
import java.util.Set;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

import org.apache.commons.io.FileUtils;
import org.apache.maven.model.Resource;
import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;
import org.apache.maven.plugin.MojoFailureException;
import org.apache.maven.project.MavenProject;
import org.apache.maven.project.MavenProjectHelper;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.Namespace;
import org.jdom.input.SAXBuilder;

/**
 * Generate messages from xml.
 * 
 * @goal generate-messages
 * @phase generate-resources
 * @threadSafe
 */
public class GenerateMessagesMojo extends AbstractMojo {

	private static final String COMMENT = "This file is automatically generated. Please do not edit this file. "
			+ "If you'd like to change the content please edit src/main/messages/*.xml";

	private static final SAXBuilder saxBuilder = new SAXBuilder();

	private static final int BUFFER = 2048;

	/**
	 * The current Maven project
	 * 
	 * @parameter expression="${project}"
	 * @readonly
	 * @required
	 */
	private MavenProject project;

	/**
	 * The directory where the XML can be fund.
	 * 
	 * @parameter expression="${project.basedir}/src/main/messages"
	 * @required
	 */
	private File resourceInputDirectory;

	/**
	 * The directory where the generated resource files will be stored. The
	 * directory will be registered as a resource root of the project such that
	 * the generated files will participate in later build phases like packaing.
	 * 
	 * @parameter expression=
	 *            "${project.build.directory}/generated-resources/messages-generated"
	 * @required
	 */
	private File resourceOutputDirectory;

	/**
	 * 
	 * @parameter expression=
	 *            "${project.build.directory}/generated-resources/messages.zip"
	 * @required
	 */
	private File messagesFile;

	/**
	 * Maven ProjectHelper.
	 * 
	 * @component
	 */
	private MavenProjectHelper projectHelper;

	@Override
	public void execute() throws MojoExecutionException, MojoFailureException {
		Object messagesMode = project.getProperties().get("messages.mode");
		if ("crowdin".equals(messagesMode)) {
			getLog().info("Skipped, using crowdin as messages.mode");
		} else {
			if (resourceInputDirectory.exists()) {

				if (hasXml()) {
					resourceOutputDirectory.mkdirs();
					transformXMLs();

					File flagFolder = new File(project.getBuild().getDirectory(), "flag-folder");
					try {
						FileUtils.writeStringToFile(new File(flagFolder, "has-messages"), "");
					} catch (IOException e) {
						throw new MojoFailureException("Failed to create flag file");
					}
					Resource resource = new Resource();
					resource.setDirectory(flagFolder.getAbsolutePath());
					this.project.addResource(resource);

					createAndAttachMessagesZip();
				}
			} else {
				getLog().info(resourceInputDirectory.getPath() + " not fund");
			}
		}
	}

	private boolean hasXml() {
		File[] listFiles = resourceInputDirectory.listFiles();
		for (File file : listFiles) {
			if (!file.isDirectory() && !file.getName().startsWith(".") && file.getName().endsWith(".xml")) {
				return true;
			}
		}
		return false;
	}

	private void createAndAttachMessagesZip() throws MojoFailureException {
		getLog().info("Creating and attaching messages.zip");
		createZip(resourceOutputDirectory, messagesFile);
		projectHelper.attachArtifact(project, "zip", "messages", messagesFile);
	}

	private void createZip(File folder, File output) throws MojoFailureException {
		try {
			output.getParentFile().mkdirs();
			FileOutputStream dest = new FileOutputStream(output);
			ZipOutputStream out = new ZipOutputStream(new BufferedOutputStream(dest));
			addFolderToZip("", folder, out);
			out.close();
		} catch (Exception e) {
			throw new MojoFailureException("Failed to create messages.zip", e);
		}
	}

	private void addFolderToZip(String path, File folder, ZipOutputStream out) throws IOException {
		BufferedInputStream origin = null;
		byte data[] = new byte[BUFFER];
		// get a list of files from current directory
		File files[] = folder.listFiles();
		for (int i = 0; i < files.length; i++) {
			File file = files[i];
			String fileName = file.getName();
			if (!fileName.startsWith(".")) {
				if (file.isDirectory()) {
					addFolderToZip(path + "/" + fileName, file, out);
				} else {
					FileInputStream fi = new FileInputStream(file);
					origin = new BufferedInputStream(fi, BUFFER);
					ZipEntry entry = new ZipEntry(path + fileName);
					out.putNextEntry(entry);
					int count;
					while ((count = origin.read(data, 0, BUFFER)) != -1) {
						out.write(data, 0, count);
					}
					origin.close();
				}
			}
		}
	}

	private Properties getProperties(String code, Map<String, Properties> propertiesMap) {
		Properties properties = propertiesMap.get(code);
		if (properties == null) {
			properties = new Properties();
			propertiesMap.put(code, properties);
		}
		return properties;
	}

	private void transformXMLs() throws MojoFailureException, MojoExecutionException {
		Map<String, Properties> propertiesMap = new HashMap<String, Properties>();

		transformXMLFolder(propertiesMap, resourceInputDirectory);

		Set<Entry<String, Properties>> entrySet = propertiesMap.entrySet();
		for (Entry<String, Properties> entry : entrySet) {
			File propertiesFile = new File(resourceOutputDirectory, entry.getKey() + ".properties");
			getLog().info("Generating " + propertiesFile.getPath());
			try {
				propertiesFile.getParentFile().mkdirs();
				FileOutputStream out = new FileOutputStream(propertiesFile);
				entry.getValue().store(out, COMMENT);
				out.close();
			} catch (IOException e) {
				throw new MojoExecutionException("Failed to save " + propertiesFile, e);
			}
		}
	}

	private void transformXMLFolder(Map<String, Properties> propertiesMap, File folder) throws MojoFailureException,
			MojoExecutionException {
		File[] listFiles = folder.listFiles();
		for (File file : listFiles) {
			if (!file.getName().startsWith(".") && file.isDirectory()) {
				transformXMLFolder(propertiesMap, file);
			}
			if (file.isFile() && file.getPath().toUpperCase().endsWith(".XML")
					&& file.getName().toUpperCase().startsWith("MESSAGES")) {
				transformXML(propertiesMap, file);
			}
		}
	}

	private void transformXML(Map<String, Properties> propertiesMap, File file) throws MojoFailureException,
			MojoExecutionException {
		getLog().info("Transforming " + file.getPath());
		Document doc;
		try {
			doc = saxBuilder.build(file);
		} catch (JDOMException e) {
			throw new MojoExecutionException("Failed to parse " + file, e);
		} catch (IOException e) {
			throw new MojoExecutionException("Failed to parse " + file, e);
		}
		Element entries = doc.getRootElement();
		List<Element> entryList = entries.getChildren("entry");
		for (Element element : entryList) {
			String keyword = element.getChildTextNormalize("keyword");
			List<Element> values = element.getChildren("text");
			for (Element valueElement : values) {
				String lang = valueElement.getAttributeValue("lang", Namespace.XML_NAMESPACE);
				String value = valueElement.getText();

				getProperties(lang, propertiesMap).put(keyword, value);
			}
		}
	}
}
